grep-commit
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

grep branch, master, updated. v2.17-3-g1179952


From: Jim Meyering
Subject: grep branch, master, updated. v2.17-3-g1179952
Date: Thu, 20 Feb 2014 22:27:04 +0000

This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "grep".

The branch, master has been updated
       via  1179952ef0728c6f8cb65214fc8be2732c2d27a3 (commit)
       via  ef5a3b579ed478a0755bae6858b02984d3bc1536 (commit)
      from  11f427a1a0bd79d7b0f6b9d62cbfe9d81ec5d06b (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
http://git.savannah.gnu.org/cgit/grep.git/commit/?id=1179952ef0728c6f8cb65214fc8be2732c2d27a3


commit 1179952ef0728c6f8cb65214fc8be2732c2d27a3
Author: Paul Eggert <address@hidden>
Date:   Wed Feb 19 18:58:42 2014 -0800

    tests: test [^^-^] in unibyte locales
    
    This is a bug in the current dfa.c, which was reintroduced by the
    recent reversion from RRI.
    * tests/unibyte-negated-circumflex: New file.
    * tests/Makefile.am (TESTS): Add it.
    * tests/init.cfg (require_unibyte_locale): New function.

diff --git a/tests/Makefile.am b/tests/Makefile.am
index e2967fa..331467a 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -75,6 +75,7 @@ TESTS =                                               \
   multibyte-white-space                                \
   empty-line-mb                                        \
   unibyte-bracket-expr                         \
+  unibyte-negated-circumflex                   \
   high-bit-range                               \
   options                                      \
   pcre                                         \
diff --git a/tests/init.cfg b/tests/init.cfg
index 2e8330b..ee5d537 100644
--- a/tests/init.cfg
+++ b/tests/init.cfg
@@ -87,6 +87,22 @@ require_compiled_in_MB_support()
     || skip_ this test requires MBS support
 }
 
+require_unibyte_locale()
+{
+  path_prepend_ .
+  for loc in C en_US; do
+    for encoding in '' .iso88591 .iso885915 .ISO8859-1 .ISO8859-15; do
+      locale=$loc$encoding
+      MB_CUR_MAX=$(get-mb-cur-max $locale 2>/dev/null) &&
+        test "$MB_CUR_MAX" -eq 1 &&
+        LC_ALL=$locale &&
+        export LC_ALL &&
+        return
+    done
+  done
+  skip_ 'no unibyte locale found'
+}
+
 expensive_()
 {
   if test "$RUN_EXPENSIVE_TESTS" != yes; then
diff --git a/tests/unibyte-negated-circumflex b/tests/unibyte-negated-circumflex
new file mode 100755
index 0000000..b6d747c
--- /dev/null
+++ b/tests/unibyte-negated-circumflex
@@ -0,0 +1,27 @@
+#!/bin/sh
+# Exercise a bug where [^^-^] was treated as if it were [^-^].
+
+# Copyright 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+require_unibyte_locale
+
+fail=0
+
+echo a >in || framework_failure_
+grep '[^^-^]' in >out || fail=1
+compare out in || fail=1
+Exit $fail

http://git.savannah.gnu.org/cgit/grep.git/commit/?id=ef5a3b579ed478a0755bae6858b02984d3bc1536


commit 1179952ef0728c6f8cb65214fc8be2732c2d27a3
Author: Paul Eggert <address@hidden>
Date:   Wed Feb 19 18:58:42 2014 -0800

    tests: test [^^-^] in unibyte locales
    
    This is a bug in the current dfa.c, which was reintroduced by the
    recent reversion from RRI.
    * tests/unibyte-negated-circumflex: New file.
    * tests/Makefile.am (TESTS): Add it.
    * tests/init.cfg (require_unibyte_locale): New function.

diff --git a/tests/Makefile.am b/tests/Makefile.am
index e2967fa..331467a 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -75,6 +75,7 @@ TESTS =                                               \
   multibyte-white-space                                \
   empty-line-mb                                        \
   unibyte-bracket-expr                         \
+  unibyte-negated-circumflex                   \
   high-bit-range                               \
   options                                      \
   pcre                                         \
diff --git a/tests/init.cfg b/tests/init.cfg
index 2e8330b..ee5d537 100644
--- a/tests/init.cfg
+++ b/tests/init.cfg
@@ -87,6 +87,22 @@ require_compiled_in_MB_support()
     || skip_ this test requires MBS support
 }
 
+require_unibyte_locale()
+{
+  path_prepend_ .
+  for loc in C en_US; do
+    for encoding in '' .iso88591 .iso885915 .ISO8859-1 .ISO8859-15; do
+      locale=$loc$encoding
+      MB_CUR_MAX=$(get-mb-cur-max $locale 2>/dev/null) &&
+        test "$MB_CUR_MAX" -eq 1 &&
+        LC_ALL=$locale &&
+        export LC_ALL &&
+        return
+    done
+  done
+  skip_ 'no unibyte locale found'
+}
+
 expensive_()
 {
   if test "$RUN_EXPENSIVE_TESTS" != yes; then
diff --git a/tests/unibyte-negated-circumflex b/tests/unibyte-negated-circumflex
new file mode 100755
index 0000000..b6d747c
--- /dev/null
+++ b/tests/unibyte-negated-circumflex
@@ -0,0 +1,27 @@
+#!/bin/sh
+# Exercise a bug where [^^-^] was treated as if it were [^-^].
+
+# Copyright 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+require_unibyte_locale
+
+fail=0
+
+echo a >in || framework_failure_
+grep '[^^-^]' in >out || fail=1
+compare out in || fail=1
+Exit $fail

-----------------------------------------------------------------------

Summary of changes:
 NEWS                                               |    5 ++
 src/dfa.c                                          |   41 ++++++++++---------
 tests/Makefile.am                                  |    1 +
 tests/init.cfg                                     |   16 ++++++++
 .../{high-bit-range => unibyte-negated-circumflex} |   11 ++---
 5 files changed, 49 insertions(+), 25 deletions(-)
 copy tests/{high-bit-range => unibyte-negated-circumflex} (78%)


hooks/post-receive
-- 
grep



reply via email to

[Prev in Thread] Current Thread [Next in Thread]